Package org.apache.sis.metadata.iso.extent

## Class AbstractGeographicExtent

- Object
- - AbstractMetadata
  - - ModifiableMetadata
    - - ISOMetadata
      - - AbstractGeographicExtent

- All Implemented Interfaces:
    `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `GeographicExtent`
  Direct Known Subclasses:
    `DefaultBoundingPolygon`, `DefaultGeographicBoundingBox`, `DefaultGeographicDescription`

      public class AbstractGeographicExtent
      extends ISOMetadata
      implements GeographicExtent

  Base class for geographic area of the dataset.

  Limitations:

  - Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
  - Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.
  Since:
    0.3
  See Also:
    Serialized Form

  Defined in the `sis-metadata` module

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class ModifiableMetadata

      `ModifiableMetadata​.State`

  - ### Field Summary

    - ### Fields inherited from class ISOMetadata

      `identifiers`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractGeographicExtent()` | Constructs an initially empty geographic extent.
    `AbstractGeographicExtent​(boolean inclusion)` | Constructs a geographic extent initialized with the specified inclusion value.
    `AbstractGeographicExtent​(GeographicExtent object)` | Constructs a new instance initialized with the values from the specified metadata object.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static AbstractGeographicExtent` | `castOrCopy​(GeographicExtent object)` | Returns a SIS metadata implementation with the values of the given arbitrary implementation.
    `Boolean` | `getInclusion()` | Indication of whether the bounding polygon encompasses an area covered by the data (inclusion) or an area where data is not present (exclusion).
    `void` | `setInclusion​(Boolean newValue)` | Sets whether the bounding polygon encompasses an area covered by the data (inclusion) or an area where data is not present (exclusion).

    - ### Methods inherited from class ISOMetadata

      `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

    - ### Methods inherited from class ModifiableMetadata

      `checkWritePermission, checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, freeze, isModifiable, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, unmodifiable, writeCollection, writeList, writeMap, writeSet`

    - ### Methods inherited from class AbstractMetadata

      `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

    - ### Methods inherited from class Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractGeographicExtent

          public AbstractGeographicExtent()

      Constructs an initially empty geographic extent.

    - #### AbstractGeographicExtent

          public AbstractGeographicExtent​(boolean inclusion)

      Constructs a geographic extent initialized with the specified inclusion value.
      Parameters:
        `inclusion` - whether the bounding polygon encompasses an area covered by the data.

    - #### AbstractGeographicExtent

          public AbstractGeographicExtent​(GeographicExtent object)

      Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the metadata to copy values from, or `null` if none.
      See Also:
        `castOrCopy(GeographicExtent)`

  - ### Method Detail

    - #### castOrCopy

          public static AbstractGeographicExtent castOrCopy​(GeographicExtent object)

      Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
      - If the given object is `null`, then this method returns `null`.
      - Otherwise if the given object is an instance of `BoundingPolygon`, `GeographicBoundingBox` or `GeographicDescription`, then this method delegates to the `castOrCopy(…)` method of the corresponding SIS subclass. Note that if the given object implements more than one of the above-cited interfaces, then the `castOrCopy(…)` method to be used is unspecified.
      - Otherwise if the given object is already an instance of `AbstractGeographicExtent`, then it is returned unchanged.
      - Otherwise a new `AbstractGeographicExtent` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, since the other metadata contained in the given object are not recursively copied.
      Parameters:
        `object` - the object to get as a SIS implementation, or `null` if none.
      Returns:
        a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

    - #### getInclusion

          public Boolean getInclusion()

      Indication of whether the bounding polygon encompasses an area covered by the data (inclusion) or an area where data is not present (exclusion).
      Specified by:
        `getInclusion` in interface `GeographicExtent`
      Returns:
        `true` for inclusion, or `false` for exclusion.

    - #### setInclusion

          public void setInclusion​(Boolean newValue)

      Sets whether the bounding polygon encompasses an area covered by the data (inclusion) or an area where data is not present (exclusion).
      Parameters:
        `newValue` - `true` if the bounding polygon encompasses an area covered by the data.